package ru.dbotthepony.mc.otm.storage

import net.minecraft.world.item.ItemStack
import ru.dbotthepony.mc.otm.core.Fraction
import java.util.*

@JvmRecord
data class ItemStackWrapper(val stack: ItemStack) : IStorageStack {
	override fun copy(): IStorageStack {
		return ItemStackWrapper(stack.copy())
	}

	fun setCount(value: Int) {
		stack.count = Math.max(value, 0)
	}

	override var count: Fraction
		get() = Fraction(stack.getCount())
		set(value) = setCount(value.toInt())

	fun getCountInt() = stack.count

	override fun getMaxStackSize(): Optional<Fraction> {
		return Optional.of(Fraction(stack.maxStackSize))
	}

	override fun isEmpty(): Boolean = stack.isEmpty
	override fun partitionKey(): Any = stack.item

	override fun sameItem(other: IStorageStack): Boolean {
		if (this === other)
			return true

		if (other is ItemStackWrapper)
			return ItemStack.isSameItemSameTags(stack, other.stack);

		return false
	}

	companion object {
		@JvmField
		val EMPTY = ItemStackWrapper(ItemStack.EMPTY)
	}
}
